(game-module "nw-europe"
  (title "NW Europe Campaign")
  (blurb "Northwest Europe Campaign, 1944-1945")
  (instructions (
  "As the Allies, your goal is to liberate France and the Low Countries,"
  "then to invade Germany and capture its cities."
  ""
  "Your time and resources will be limited."
  ""
  "As the Germans, your goal is to delay and beat back the Allies as long "
  "as possible, with even fewer resources."
  ))
  (base-module "ww2-div-eur")
  (variants
   (see-all false)
   )
  )

(set synthesis-methods '(name-units-randomly))

(scorekeeper (do last-side-wins))

(set last-turn 30)

(set initial-date "1 Jun 1944")

(set season-names
  ((0 15 "summer") (16 25 "autumn") (26 40 "winter")))

(side 1 (name "Allies") (adjective "Allied") (class "allies")
  (color "blue") (emblem-name "white-star"))

(side 2 (name "Axis") (adjective "Axis") (class "axis")
  (color "black") (emblem-name "german-cross"))

(include "t-nw-eur")

(add u* already-seen 100)

(a-inf 24 47 1 (n "Br 15"))
(a-inf 22 47 1 (n "Br 3"))
(a-inf 24 47 1 (n "Br 43"))
(a-inf 24 47 1 (n "Br 49"))
(a-inf 25 47 1 (n "Br 50"))
(a-inf 25 47 1 (n "Br 51"))
(a-inf 25 47 1 (n "Br 52"))
(a-inf 26 47 1 (n "Br 53"))
(a-inf 26 47 1 (n "Can 2"))
(a-inf 27 47 1 (n "Can 3"))
(a-inf 22 49 1 (nb 1))
(a-inf 22 49 1 (nb 2))
(a-inf 23 48 1 (nb 29))
(a-inf 23 48 1 (nb 30))
(a-inf 22 48 1 (nb 4))
(a-inf 22 48 1 (nb 5))
(a-inf 24 48 1 (nb 79))
(a-inf 22 48 1 (nb 8))
(a-inf 22 47 1 (nb 83))
(a-inf 23 48 1 (nb 9))
(a-inf 22 47 1 (nb 90))
(a-inf 1 68 1 (nb 26))
(a-inf 2 68 1 (nb 35))
(a-inf 3 68 1 (nb 42))
(a-inf 4 68 1 (nb 44))
(a-inf 5 68 1 (nb 63))
(a-inf 1 67 1 (nb 65))
(a-inf 2 67 1 (nb 66))
(a-inf 3 67 1 (nb 69))
(a-inf 4 67 1 (nb 70))
(a-inf 5 67 1 (nb 71))
(a-inf 2 66 1 (nb 75))
(a-inf 3 66 1 (nb 76))
(a-inf 4 66 1 (nb 78))
(a-inf 5 66 1 (nb 80))
(a-inf 6 66 1 (nb 84))
(a-inf 2 65 1 (nb 87))
(a-inf 3 65 1 (nb 89))
(a-inf 4 65 1 (nb 94))
(a-inf 5 65 1 (nb 95))
(a-inf 6 65 1 (nb 99))
(a-inf 3 64 1 (nb 100))
(a-inf 4 64 1 (nb 102))
(a-inf 5 64 1 (nb 103))
(a-inf 6 64 1 (nb 104))
(a-inf 7 64 1 (nb 106))
(a-armor 21 47 1 (n "Gds"))
(a-armor 21 47 1 (nb 2))
(a-armor 23 46 1 (nb 3))
(a-armor 23 46 1 (nb 4))
(a-armor 4 61 1 (nb 7))
(a-armor 5 61 1 (nb 8))
(a-armor 6 61 1 (nb 9))
(a-armor 4 60 1 (nb 10))
(a-armor 5 60 1 (nb 11))
(a-armor 6 60 1 (nb 12))
(a-armor 5 59 1 (nb 13))
(a-armor 6 59 1 (nb 14))
(a-armor 7 59 1 (nb 16))
(a-armor 19 47 1 (n "Can 4"))
(a-armor 18 47 1 (n "Pol 1"))
(a-armor 17 47 1 (n "Fr 2DB"))
(a-para 20 48 1 (n "Br 1"))
(a-para 20 47 1 (n "Br 6"))
(a-para 20 47 1 (nb 101))
(a-para 20 47 1 (nb 82))
(hq 23 49 1 (n "British 2nd"))
(hq 23 49 1 (nb 1))
(transport 21 46 1)
(transport 22 46 1)
(transport 24 46 1)
(transport 25 46 1)
(transport 26 46 1)
(battleship 22 45 1)
(battleship 24 45 1)
(battleship 26 45 1)

(bomber 29 58 1 (in base1))
(bomber 25 62 1 (in base2))
(bomber 32 52 1 (in base3))
(bomber 27 48 1 (in base4))
(bomber 20 50 1 (in base5))
(bomber 24 58 1 (in base6))

(airbase 29 58 1 (sym base1))
(airbase 25 62 1 (sym base2))
(airbase 32 52 1 (sym base3))
(airbase 27 48 1 (sym base4))
(airbase 20 50 1 (sym base5))
(airbase 24 58 1 (sym base6))

(town 34 52 1 (n "Dover"))
(town 23 47 1 (n "Portsmouth"))

(g-inf 63 4 2 (nb 271))
(g-inf 64 3 2 (nb 272))
(g-inf 27 23 2 (nb 275))
(g-inf 44 5 2 (nb 276))
(g-inf 65 2 2 (nb 277))
(g-inf 41 51 2 (nb 331))
(g-inf 29 36 2 (nb 352))
(g-inf 26 30 2 (nb 77))
(g-inf 34 41 2 (nb 84))
(g-inf 37 50 2 (nb 85))
(g-inf 25 36 2 (nb 91))
(g-armor 45 4 2 (nb 11))
(g-armor 39 38 2 (nb 116))
(g-armor 49 52 2 (n "1SS"))
(g-armor 43 42 2 (nb 2))
(g-armor 32 35 2 (nb 21))
(g-armor 67 2 2 (n "2SS"))
(g-armor 58 2 2 (nb 9))
(g-armor 45 26 2 (n "Lehr"))
(g-para 17 29 2)
(pzgren 45 16 2 (n "17SS"))
(cd 58 7 2 (nb 148))
(cd 59 6 2 (nb 157))
(cd 43 7 2 (nb 159))
(cd 44 56 2 (nb 165))
(cd 33 39 2 (n "17LW"))
(cd 38 52 2 (nb 182))
(cd 60 5 2 (nb 189))
(cd 41 53 2 (n "18LW"))
(cd 61 4 2 (nb 242))
(cd 23 38 2 (nb 243))
(cd 62 3 2 (nb 244))
(cd 38 42 2 (nb 245))
(cd 22 25 2 (nb 265))
(cd 19 33 2 (nb 266))
(cd 48 34 2 (n "325S"))
(cd 40 53 2 (nb 326))
(cd 63 2 2 (nb 338))
(cd 16 31 2 (nb 343))
(cd 37 48 2 (nb 344))
(cd 34 38 2 (nb 346))
(cd 38 43 2 (nb 348))
(cd 37 51 2 (nb 47))
(cd 42 54 2 (nb 48))
(cd 37 49 2 (nb 49))
(cd 27 37 2 (nb 709))
(cd 35 37 2 (nb 711))
(cd 43 55 2 (nb 712))
(cd 31 36 2 (nb 716))
(hq 43 41 2 (nb 15))
(hq 65 4 2 (nb 19))
(hq 31 26 2 (nb 7))
(train 48 51 2)
(train 48 50 2)
(train 56 47 2)
(train 46 35 2)
(train 47 33 2)
(train 17 30 2)
(train 44 6 2)
(train 62 5 2)

(v2-base 45 61 2)
(v2-base 45 62 2)
(v2-base 46 61 2)

(town 42 42 2 (n "Amiens") (os 1))
(town 46 62 2 (n "Amsterdam") (os 1))
(town 48 53 2 (n "Antwerp") (os 1))
(town 51 59 2 (n "Arnhem") (os 1))
(town 29 32 2 (n "Avranches") (os 1))
(town 43 6 2 (n "Bordeaux") (os 1))
(town 17 29 2 (n "Brest") (os 1))
(town 49 50 2 (n "Brussels") (os 1))
(town 32 35 2 (n "Caen") (os 1))
(town 37 52 2 (n "Calais") (os 1))
(town 24 39 2 (n "Cherbourg") (os 1))
(town 37 42 2 (n "Dieppe") (os 1))
(town 63 24 2 (n "Dijon") (os 1))
(town 57 55 2 (n "Duisburg"))
(town 40 53 2 (n "Dunkerque") (os 1))
(town 58 54 2 (n "Dusseldorf"))
(town 70 47 2 (n "Frankfurt"))
(town 44 50 2 (n "Ghent") (os 1))
(town 60 51 2 (n "Koln"))
(town 34 38 2 (n "Le Havre") (os 1))
(town 38 26 2 (n "Le Mans") (os 1))
(town 54 49 2 (n "Liege") (os 1))
(town 43 47 2 (n "Lille") (os 1))
(town 45 16 2 (n "Loudun") (os 1))
(town 71 42 2 (n "Mannheim"))
(town 60 38 2 (n "Metz") (os 1))
(town 62 33 2 (n "Nancy") (os 1))
(town 31 19 2 (n "Nantes") (os 1))
(town 57 56 2 (n "Oberhausen"))
(town 48 27 2 (n "Orleans") (os 1))
(town 46 34 2 (n "Paris") (os 1))
(town 52 37 2 (n "Reims") (os 1))
(town 30 27 2 (n "Rennes") (os 1))
(town 45 59 2 (n "Rotterdam") (os 1))
(town 40 38 2 (n "Rouen") (os 1))
(town 64 38 2 (n "Saarbruecken"))
(town 52 29 2 (n "Sens") (os 1))
(town 23 31 2 (n "St Brieuc") (os 1))
(town 26 31 2 (n "St Malo") (os 1))
(town 71 34 2 (n "Strasbourg") (os 1))
(town 81 36 2 (n "Stuttgart"))
(town 43 20 2 (n "Tours") (os 1))
(town 60 42 2 (n "Trier"))
(town 25 38 2 (n "Valognes") (os 1))
(town 46 33 2 (n "Versailles") (os 1))
(town 69 45 2 (n "Wiesbaden"))
(town 64 47 2 (n "Koblenz"))
(town 57 50 2 (n "Aachen"))
(town 56 54 2 (n "Moenchen-Gladbach"))
(town 59 55 2 (n "Essen"))
(town 61 55 2 (n "Dortmund"))
(town 60 59 2 (n "Munster"))
(town 44 60 2 (n "The Hague") (os 1))
